/*
Script Arduino-UNO for the Klannbot KL-204 spider
Please modify the infrared remote control HEX values
Copyleft : Roberto Hamm - roberto.hamm@sfr.fr
http://robotix.ah-oui.org (25/02/2020)
*/ 

#include "AFMotor.h"
#include "IRremote.h"

// const int MOTOR_1 = 1;
// AF_DCMotor motor1(MOTOR_1,MOTOR12_64KHZ);

const int Mo1 = 1;
const int Mo2 = 2;
const int Mo3 = 3;
const int Mo4 = 4;


AF_DCMotor Mt_A(Mo3,MOTOR12_64KHZ);
AF_DCMotor Mt_B(Mo4,MOTOR12_64KHZ);

// change to the HEX values of your remote control !
#define FWRD 0xFFE01F
#define BKWD 0xFFC03F
#define LEFT 0xFF807F
#define RGHT 0xFFD827
#define STOP 0xFF40BF
#define SPEED 0xFF20DF

int spd = 250;

int irPin = A0; // IRcode
IRrecv reception_ir(irPin);
decode_results decode_ir;
unsigned int value;

void setup(){
Serial.begin(9600);
Serial.println("Projet- KL-20_200311-04");

Mt_A.setSpeed(spd);
Mt_B.setSpeed(spd);

reception_ir.enableIRIn(); // IRcode

int spd = 260;
}

void loop(){
if(reception_ir.decode(&decode_ir) ) // IRcode

{Serial.println(decode_ir.value,HEX);

switch(decode_ir.value){

case SPEED:
//int slw = 180;
//int fst = 255;
if(spd != 180){spd = 180;} else {spd = 255;} 
Serial.print(spd); Serial.println(" SPEED"); 
break;


case FWRD:
if(spd != 180){spd = 180;} else {spd = 255;} 
Serial.print(spd); Serial.println(" FWRD");
fwrd(100,spd,spd); 
break;

case BKWD:
if(spd != 180){spd = 180;} else {spd = 255;} 
Serial.print(spd); Serial.println(" BKWD");
bkwd(100,spd,spd);
break;

case RGHT:
Serial.print(spd); Serial.println(" RGHT");
rght(100,200,200);
break;

case LEFT:
Serial.print(spd); Serial.println(" LEFT");
left(100,200,200);
break;

case STOP:
Serial.println("STOP");
stall(2000);
break;
} // switch

reception_ir.resume(); // IRcode
} // if IR
} // loop


////////////////// functions /////////////////

void fwrd(int del,int spd_A,int spd_B){
Mt_A.setSpeed(spd_A);
Mt_B.setSpeed(spd_B);
Mt_A.run(FORWARD);
Mt_B.run(FORWARD);
}

void bkwd(int del,int spd_A,int spd_B){
Mt_A.setSpeed(spd_A);
Mt_B.setSpeed(spd_B);
Mt_A.run(BACKWARD);
Mt_B.run(BACKWARD);
}

void rght(int del,int spd_A,int spd_B){
Mt_A.setSpeed(spd_A);
Mt_B.setSpeed(spd_B);
Mt_A.run(BACKWARD);
Mt_B.run(FORWARD);
}

void left(int del,int spd_A,int spd_B){
Mt_A.setSpeed(spd_A);
Mt_B.setSpeed(spd_B);
Mt_A.run(FORWARD);
Mt_B.run(BACKWARD);
}

void stall(int del){
Mt_A.setSpeed(0);
Mt_B.setSpeed(0);
Mt_A.run(BRAKE);
Mt_B.run(BRAKE);
delay(del);
Mt_A.run(RELEASE);
Mt_B.run(RELEASE);
}



